﻿using static AsReader251GMAUIDemo.Platforms.Droid.AsReader251GDefine;

namespace AsReader251GMAUIDemo.Platforms.Droid
{
	public class AsReader251GDelegate
    {
        public delegate void OnStateChangedDelegate(AsReader251G_ConnectionState state);
        public OnStateChangedDelegate OnStateChanged;

        public delegate void OnReadTagDelegate(AsReader251G_ActionState p1, string p2, float p3, float p4, float p5);
        public OnReadTagDelegate OnReadTag;
       
        public delegate void OnReadBarcodeDelegate(string p1, string p2, string p3);
        public OnReadBarcodeDelegate OnReadBarcode;

        public delegate void OnKeyEventDelegate(AsReader251G_KeyType p1, AsReader251G_KeyState p2);
        public OnKeyEventDelegate OnKeyEvent;
        
        public delegate void OnExceptionOccurredDelegate(int p1);
        public OnExceptionOccurredDelegate OnExceptionOccurred;
       
        public delegate void OnActionChangedDelegate(AsReader251G_ActionState p1);
        public OnActionChangedDelegate OnActionChanged;

        static AsReader251GDelegate uniqueInstance;

        static readonly object locker = new object();

        public static AsReader251GDelegate sharedInstance()
        {
            if (uniqueInstance == null)
            {
                lock (locker)
                {
                    if (uniqueInstance == null)
                    {
                        uniqueInstance = new AsReader251GDelegate();
                    }
                }
            }
            return uniqueInstance;
        }
        public AsReader251GDelegate()
        {

        }
    }
}

